/*
 * Top Level of a digital pulses generator with differential outputs.
 * 
 * This module is the Vivado top-level of the Crono Signal Generator Arty Z7-10.
 * This project is aimed to be used with the Arty Z7-10 board.
 * Here, we generate some pulses with the FPGA when the GPIOs detects a rising edge.
 *
 * Author: Julian Rodriguez <jnrodriguez@estudiantes.unsam.edu.ar>
 */

module top_level_crono_signal_generator(i_start,i_reset,i_base_clk,o_pattern_generator_n,o_pattern_generator_p,o_debug_led);
    /* Useful local parameters (just to not use magic numbers). */
    localparam OUTPUT_SIGNALS_QTY = 2;
    localparam SYSTEM_CLOCK_FREQUENCY_HZ = 250000000;

    input i_reset;
    input i_base_clk;           // base clock generated by the fpga
    input [OUTPUT_SIGNALS_QTY-1:0] i_start; // input used to start the pattern generator
    output [OUTPUT_SIGNALS_QTY-1:0] o_pattern_generator_p; // positive output used to transmit test pattern signals
    output [OUTPUT_SIGNALS_QTY-1:0] o_pattern_generator_n; // negative output used to transmit test pattern signals
    output o_debug_led;
    
    /*- Clock generation ----------------------------------------------------*/
    wire w_clk;
    clk_wiz_0 clock_gen(
        .o_clk(w_clk),  // output o_clk
        .reset(i_reset),// input reset
        .locked(),
        .i_clk(i_base_clk)  // input clock
    );


    wire [OUTPUT_SIGNALS_QTY-1:0] w_pattern_single_ended;
    genvar i;
    generate
        for(i = 0; i < OUTPUT_SIGNALS_QTY; i = i + 1) begin
        /*- Pattern generators ----------------------------------------------*/
            pattern_generator #(
                .PATTERN_SIZE(10),
                .PATTERN(10'b1010001010)
            ) pattern_generator_inst (
                .i_start(i_start[i]),
                .i_clk(w_clk),
                .i_reset(i_reset),
                .o_pattern(w_pattern_single_ended[i]),
                .o_valid()
            );

        /*- Differential output buffers -------------------------------------*/
            OBUFDS diff_buffer_inst (
                .I(w_pattern_single_ended[i]), // 1-bit input: single ended input
                .O(o_pattern_generator_p[i]),   // 1-bit output: Positive buffer output
                .OB(o_pattern_generator_n[i])   // 1-bit output: Negative buffer output
            );
        end
        
    endgenerate

    
    /* Simple led that toggles every DEBUG_LED0_TOGGLE_PERIOD_MS milliseconds. */
    timed_toggler #(
        .TOGGLE_PERIOD_MS(1000),
        .CLOCK_FREQUENCY_HZ(SYSTEM_CLOCK_FREQUENCY_HZ)
    ) debug_led_blinker (
        .i_clk          (w_clk),
        .i_reset        (i_reset),
        .o_toggle_out   (o_debug_led)
    );


endmodule
